package cpcns.dingZhi.impAndexpUtil.controller;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import cpcns.base.common.User;
import cpcns.base.configuration.AppConfiguration;
import cpcns.dangAnBase.base.controller.DangAnBaseController;
import cpcns.dingZhi.impAndexpUtil.dao.ExpDao;
import cpcns.dingZhi.impAndexpUtil.service.ExpService;
import cpcns.dingZhi.impAndexpUtil.service.ImpService;
import cpcns.utils.Json;
import cpcns.wenjianshouji.util.FileUtil;
import cpcns.wenjianshouji.util.ZipUtil;
import java.io.File;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import net.sf.json.JSONObject;
import org.apache.commons.io.FileUtils;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.multipart.commons.CommonsMultipartResolver;

@Controller
@RequestMapping({"impAndexp"})
public class ImpAndexpController extends DangAnBaseController {
  @Autowired
  private ExpService expService;
  
  @Autowired
  private ImpService impService;
  
  @Autowired
  private ExpDao expDao;
  
  @RequestMapping({"/getMenLeiMingCheng.do"})
  @ResponseBody
  public String getMenLeiMingCheng() {
    String result = null;
    Map<String, Object> resultMap = new HashMap<>();
    try {
      List<Map<String, Object>> xtdmList = this.expDao.getListHqlpoge("select \tMINGCHENG,FENLEIHAO from G_DANGANMENLEI\t");
      resultMap.put("success", Integer.valueOf(0));
      resultMap.put("info", "查询成功");
      resultMap.put("result", xtdmList);
      result = Json.Map2Json(resultMap);
    } catch (Exception e) {
      System.out.println(e.getMessage());
    } 
    return result;
  }
  
  @RequestMapping({"/request.do"})
  public String request(String value, Model model, String table, String state, String outParse, String tiShi) {
    model.addAttribute("value", value);
    model.addAttribute("table", table);
    if (StringUtils.isNotBlank(state)) {
      model.addAttribute("outParse", outParse);
      model.addAttribute("tiShi", tiShi);
      return "dingZhi/impAndExp/DaoChuShuJuQianYi";
    } 
    return "dingZhi/impAndExp/DaoRuShuJuQianYi";
  }
  
  @RequestMapping(value = {"/importZip.do"}, method = {RequestMethod.POST})
  public String inprotZip(@RequestParam("outPutType") String outPutType, @RequestParam("table") String table, @RequestParam("number") String number, HttpServletRequest request, HttpServletResponse response, Model model) {
    String FILE_UPLOAD_PATH = String.valueOf(AppConfiguration.getConfigValue("OACaiJiPath")) + "/temp";
    String FILE_STORE_PATH = String.valueOf(AppConfiguration.getConfigValue("OACaiJiPath")) + "/temp";
    JSONObject jsonObject = new JSONObject();
    String num = "";
    try {
      try {
        jsonObject.put("result", Boolean.valueOf(true));
        jsonObject.put("message", "导入成功");
        jsonObject.put("success", Integer.valueOf(1));
        String genFileName = null;
        String zipFilePath = null;
        String filePath = null;
        deleteLinShiFile();
        HttpServletRequest request_ = ((ServletRequestAttributes)RequestContextHolder.getRequestAttributes()).getRequest();
        User user = (User)request_.getSession().getAttribute("cpcns.sso.client.filter.user");
        CommonsMultipartResolver multipartResolver = new CommonsMultipartResolver(request.getSession().getServletContext());
        if (multipartResolver.isMultipart(request)) {
          MultipartHttpServletRequest multiRequest = (MultipartHttpServletRequest)request;
          Iterator<String> iter = multiRequest.getFileNames();
          while (iter.hasNext()) {
            MultipartFile file = multiRequest.getFile(iter.next());
            if (file != null) {
              String myFileName = file.getOriginalFilename();
              if (myFileName.trim() != "") {
                genFileName = FileUtil.createRandomFileName(".zip");
                zipFilePath = String.valueOf(FILE_UPLOAD_PATH) + "/" + genFileName;
                File localFile = new File(zipFilePath);
                file.transferTo(localFile);
              } 
            } 
          } 
        } 
        String deFileName = genFileName.substring(0, genFileName.indexOf(".zip"));
        String saveFileDir = String.valueOf(FILE_STORE_PATH) + "/" + deFileName;
        ZipUtil.unzip(zipFilePath, saveFileDir);
        String xmlFileUrl = getDirfile(saveFileDir);
        if ("1".equals(outPutType)) {
          num = this.impService.inportXm(xmlFileUrl, saveFileDir, getFtpQuanZong(), table, number);
        } else if ("2".equals(outPutType)) {
          num = this.impService.inportAnJuan(xmlFileUrl, saveFileDir, getFtpQuanZong(), table, number);
        } else if ("3".equals(outPutType)) {
          num = this.impService.inportWenJian(xmlFileUrl, saveFileDir, getFtpQuanZong(), table, number);
        } 
        String[] list = num.split(",");
        jsonObject.put("sum", list[0]);
        jsonObject.put("chongfusNum", list[1]);
        jsonObject.put("zhixingNum", list[2]);
        jsonObject.put("fjNum", list[3]);
      } catch (Exception e) {
        jsonObject.put("result", Boolean.valueOf(false));
        jsonObject.put("success", Integer.valueOf(0));
        jsonObject.put("message", "导入失败");
      } 
      write(response, jsonObject.toString());
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return null;
  }
  
  @RequestMapping({"/exportZip.do"})
  @ResponseBody
  public String exportZip(HttpServletRequest request, HttpServletResponse response) {
    JSONObject jsonObject = new JSONObject();
    jsonObject.put("result", Boolean.valueOf(true));
    jsonObject.put("message", "导出成功");
    String[] excelArray = (String[])null;
    try {
      try {
        String quanZhongHao = getFtpQuanZong();
        String outPutType = getRequest().getParameter("outPutType");
        String guiDangNianDu = getRequest().getParameter("guiDangNianDu");
        String guiDangNianDu_Operator = getRequest().getParameter("guiDangNianDu_Operator");
        String baoGuanQiXian = getRequest().getParameter("baoGuanQiXian");
        String table = getRequest().getParameter("table");
        String HBS = getRequest().getParameter("HBS");
        String leixing = getRequest().getParameter("leixing");
        String menlei = getRequest().getParameter("menlei");
        String outType = getRequest().getParameter("outType");
        String yuanWen = getRequest().getParameter("xzyw");
        if ("1".equals(yuanWen)) {
          yuanWen = "yes";
        } else {
          yuanWen = "no";
        } 
        String exceArr = request.getParameter("excelTitle");
        if (StringUtils.isNotBlank(exceArr))
          excelArray = request.getParameter("excelTitle").split(","); 
        String qybl = "";
        deleteLinShiFile();
        if ("1".equals(outPutType)) {
          qybl = this.expService.exportXM(HBS, table, "XM", quanZhongHao, yuanWen, outType, response, excelArray);
        } else if ("2".equals(outPutType)) {
          qybl = this.expService.exportAnJuan(HBS, table, "AJ", guiDangNianDu, baoGuanQiXian, quanZhongHao, guiDangNianDu_Operator, yuanWen, outType, response, menlei, excelArray);
        } else if ("3".equals(outPutType)) {
          qybl = this.expService.exportWenJian(HBS, table, "WJ", guiDangNianDu, baoGuanQiXian, quanZhongHao, guiDangNianDu_Operator, leixing, menlei, yuanWen, outType, response, excelArray);
        } 
        if ("-1".equals(qybl)) {
          jsonObject.put("result", Boolean.valueOf(false));
          jsonObject.put("message", "没有导出数据");
        } else if ("-2".equals(qybl)) {
          jsonObject.put("result", Boolean.valueOf(false));
          jsonObject.put("message", "导出数据超出最大限制");
        } else {
          String url = String.valueOf(request.getScheme()) + "://" + request.getServerName() + ":" + request.getServerPort() + "/CPCNS0412_DianZiDangAn/CPCNS/upload/temp/" + qybl;
          jsonObject.put("url", url);
        } 
      } catch (Exception e) {
        System.out.println(e.getMessage());
        jsonObject.put("result", Boolean.valueOf(false));
        jsonObject.put("message", "导出失败");
      } 
      write(response, jsonObject.toString());
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return null;
  }
  
  public void deleteLinShiFile() {
    try {
      synchronized (cpcns.dingZhi.impAndexpUtil.controller.ImpAndexpController.class) {
        String pathfile = String.valueOf(AppConfiguration.getConfigValue("OACaiJiPath")) + "/temp";
        File file = new File(pathfile);
        FileUtils.deleteDirectory(file);
        if (!file.exists())
          file.mkdirs(); 
      } 
    } catch (Exception e) {
      System.out.println("删除临时目录失败！");
    } 
  }
  
  public static String getDirfile(String path) {
    String xmlFileUrl = "";
    File file = new File(path);
    File[] fileList = file.listFiles();
    for (int i = 0; i < fileList.length; i++) {
      if (fileList[i].isFile() && (fileList[i].getName().indexOf(".xml") != -1 || fileList[i].getName().indexOf(".xml") != -1))
        xmlFileUrl = fileList[i].toString(); 
    } 
    return xmlFileUrl;
  }
}
